/*
 * Copyright (c) 2002-2011 Nokia Corporation and/or its subsidiary(-ies). All rights reserved.
 *    
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *    
 *  * Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *  * Neither the name of Nokia Corporation nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *    
 *    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 *    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 *    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 *    SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *    CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 *    OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *    
 *    Description: CEmployee declaration 
 */ 


#ifndef EMPLOYEE_H
#define EMPLOYEE_H

// INCLUDES
#include <e32std.h>
#include <e32base.h>
#include <s32file.h>

// CONSTANTS
const TInt KMaxEmployeeName   = 40;
const TInt KMaxEmployeeNumber = 20;

// CLASS DECLARATION

class CEmployee: public CBase
	{
public: // New methods
	CEmployee();

	void SetIdentifier(TUint32 aIdentifier)
	{ iIdentifier = aIdentifier; }
	
	TUint32 Identifier() const
	{ return iIdentifier; }
	
	void SetName(const TDesC& aName)
	{ iName.Copy(aName); }
	
	const TPtrC Name() const
	{ return iName; }
	
	void SetPhoneNumber(const TDesC& aPhoneNumber)
	{ iPhoneNumber.Copy(aPhoneNumber); }
	
	const TPtrC PhoneNumber() const
	{ return iPhoneNumber; }
	
	void InternalizeL(RReadStream& aStream);
	void ExternalizeL(RWriteStream& aStream) const;

private:
	TUint32                  iIdentifier;
	TBuf<KMaxEmployeeName>   iName;
	TBuf<KMaxEmployeeNumber> iPhoneNumber;
	};

#endif // EMPLOYEE_H
	
// End of File
